<template>
  <q-dialog v-model="showDialog" @hide="closeDialog" persistent>
    <q-card style="width: 900px; max-width: 80vw">
      <q-bar>
        Envio de mensaje masivo a los participantes
        <q-space />
        <q-btn dense flat icon="close" v-close-popup @click="CancelarDialog">
          <q-tooltip>Close</q-tooltip>
        </q-btn>
      </q-bar>
      <q-card-section class="q-pa-none">
        <q-editor
          v-model="mensaje"
          placeholder="Escriba el mensaje a enviar"
          dense
        />
      </q-card-section>
      <q-card-actions align="right">
        <q-btn
          flat
          label="Enviar mensaje"
          color="primary"
          v-close-popup
          @click="enviarMensaje"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script lang="ts">
import { defineComponent, ref, watch } from 'vue';
import { api } from 'src/boot/axios/index';
import { useRoute } from 'vue-router';
import { useQuasar } from 'quasar';

export default defineComponent({
  name: 'AccionesEnviarMensajeMasivoPartial',
  props: {
    show: Boolean,
  },
  emits: ['update:show', 'close'],

  setup(props, { emit }) {
    const route = useRoute();
    const uuid = route.params.uuid || '';
    const $q = useQuasar();
    const showDialog = ref(props.show);

    watch(
      () => props.show,
      (newValue) => {
        showDialog.value = newValue;
      }
    );

    const mensaje = ref('');

    function enviarMensaje() {
      if (mensaje.value.trim() === '') {
        $q.notify({
          message: 'Debe ingresar un mensaje',
          color: 'red',
          position: 'top',
        });
        return;
      }

      api
        .post('/api/eventos/eventos/email/masivo', {
          texto: mensaje.value,
          evento_uuid: uuid,
        })
        .then(() => {
          mensaje.value = '';
          closeDialog();
        });
    }

    function CancelarDialog() {
      $q.notify({
        message: 'Envio de mensaje masivo cancelado',
        color: 'red',
        position: 'top',
      });
      closeDialog();
    }

    function closeDialog() {
      showDialog.value = false;
      emit('update:show', false);
      emit('close');
    }

    return {
      showDialog,
      closeDialog,
      CancelarDialog,
      mensaje,
      enviarMensaje,
    };
  },
});
</script>
